unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Grids, Menus, Buttons, ComCtrls,
  realtimer,Shellapi, ImgList, ToolWin,FlagDisplay,rTimeDlg,
  AppEvnts, Spin, math, tTProg, kemo_usb, registry;

const
  kemo_USBPort  = 0;
  kemo_USBPort2  = 1;
  kemo_USBPort3  = 2;
  kemo_USBPort4  = 3;
  kemo_USBPort5  = 4;

  RegistryFolderBase: string = '\SOFTWARE\KEMO\RELAISTIMER';

//curr 0101
//mask 0011  // 0 = abs change  1= toggle
//new  1001
//out  1000
type

  TInp32proc = function(PortAddress: short):short; stdcall;
  TOut32proc = procedure(PortAddress: short;data: short); stdcall;

  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    NewProject1: TMenuItem;
    OpenProject1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Exit1: TMenuItem;
    Help1: TMenuItem;
    Help2: TMenuItem;
    About1: TMenuItem;
    Readme1: TMenuItem;
    HilfeDeutsch1: TMenuItem;
    N1: TMenuItem;
    ImageList1: TImageList;
    ScrollBox1: TScrollBox;
    DrawGrid1: TDrawGrid;
    Panel2: TPanel;
    bStep: TSpeedButton;
    bStart: TButton;
    bStop: TButton;
    CheckBox1: TCheckBox;
    ApplicationEvents1: TApplicationEvents;
    Panel1: TPanel;
    Shape1: TShape;
    bAllOFF: TSpeedButton;
    bAllON: TSpeedButton;
    Label12: TLabel;
    Label11: TLabel;
    Label10: TLabel;
    Label9: TLabel;
    GroupBox1: TGroupBox;
    SpinEdit4: TSpinEdit;
    SpinEdit3: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit1: TSpinEdit;
    bInsert: TButton;
    Label2: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    GroupBox2: TGroupBox;
    bDelete: TButton;
    bEdit: TButton;
    Shape2: TShape;
    RadioGroup1: TRadioGroup;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    ImageList3: TImageList;
    ImageList2: TImageList;
    ComboBox1: TComboBox;
    Label8: TLabel;
    Label4: TLabel;
    SpeedButton3: TSpeedButton;
    ImageList4: TImageList;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure bEditClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure OpenProject1Click(Sender: TObject);
    procedure NewProject1Click(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Readme1Click(Sender: TObject);
    procedure Help2Click(Sender: TObject);
    procedure HilfeDeutsch1Click(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure bInsertClick(Sender: TObject);
    procedure DrawGrid1DblClick(Sender: TObject);
    procedure bStartClick(Sender: TObject);
    procedure bStopClick(Sender: TObject);
    procedure bAllOFFClick(Sender: TObject);
    procedure bAllONClick(Sender: TObject);
    procedure bStepClick(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure bDeleteClick(Sender: TObject);
    procedure DrawGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
    procedure SpinEdit3KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure SpinEdit1Exit(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure ApplicationEvents1ShortCut(var Msg: TWMKey; var Handled: Boolean);
    procedure DrawGrid1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    usb: TKemoUSB;

    CloseRelaisTimerOnEndOfProgram: integer;
    isEditing: boolean;
    FlagDisplay1,
    FlagDisplay2: TFlagDisplay;
    TimerProgram: TrtProgram;
    CurrentState: cardinal; // current state as one value (for port operation)
    hInOutLib: HMODULE; // handle for driver dll

    Inp32: TInp32proc; // function for reading ports
    Out32: TOut32proc; // function for writing port

    IOPort: integer; // IO port
    CurProject: string;
    procedure LoadFromFile(CurProject: string);
    procedure CmdProgramFinished(Sender: TObject);
    procedure FlagDisplay1Change(Sender: TObject);
    procedure AddRow;
    procedure CmdStateChange(StateMask: cardinal);
    procedure ToggleSelectedFlagDisplay(index: integer);
    procedure DeleteSelectedRow;
    procedure SortProgramList;
    procedure PortSettingsChanged;
    procedure wmDeviceChange(var Message: TMessage); message WM_DEVICECHANGE;



    function NeedVistaOr64bitInputDll: integer;
    procedure SelectedItemIncTime(t: double);
  protected
    procedure MsgLastError;
  public
    procedure ApplyState; // applies current states
  end;

var
  MainForm: TMainForm;
  AppPath: string;

implementation
const
DEG2RAD = pi/180;

{$R *.dfm}
procedure TMainForm.MsgLastError;
var lpMsgBuf: pChar;
begin
  FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER or FORMAT_MESSAGE_FROM_SYSTEM,nil,GetLastError,0,@lpMsgBuf,0,nil);
  Application.MessageBox(lpMsgBuf,'Error WriteFile()');
  LocalFree(cardinal(lpMsgBuf));
end;

procedure TMainForm.CmdProgramFinished(Sender: TObject);
begin
//  Button9.Caption := 'Start';
  if CloseRelaisTimerOnEndOfProgram=1 then CloseRelaisTimerOnEndOfProgram:=2;
end;

procedure TMainForm.FlagDisplay1Change(Sender: TObject);
begin
  CurrentState := FlagDisplay1.State;
  ApplyState;
end;

procedure TMainForm.CmdStateChange(StateMask: cardinal);
var m,f: cardinal;
begin                                       //curr 0101
                                            //mask 0011  // 0 = abs change  1= toggle
                                            //new  1001
                                            //out  1000
  m:=StateMask shr 16;
  f:=StateMask and $ffff;
  CurrentState := CurrentState xor f;
  CurrentState := (CurrentState and m) or (f and not m);
  FlagDisplay1.State := CurrentState;
  DrawGrid1.Invalidate;
end;

function TMainForm.NeedVistaOr64bitInputDll: integer;
var
  h: cardinal;
  fnIsWow64Process: function(ProcessHandle: cardinal; var IsWow64: LongBool): LongBool; stdcall;
  b: LongBool;
begin
  result := 0;
  h:=GetModuleHandle('kernel32');
  if h=0 then exit;
  @fnIsWow64Process := GetProcAddress(h,'IsWow64Process');
  if @fnIsWow64Process=nil then exit;
  fnIsWow64Process(GetCurrentProcess,b);
  if b then result := 1;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin

  DrawGrid1.DoubleBuffered := false;

  AppPath:= ExtractFilePath(Application.ExeName);
  DecimalSeparator := '.';
  ThousandSeparator := ',';

  TimerProgram:= TrtProgram.Create;
  TimerProgram.OnStateChange := CmdStateChange;
  TimerProgram.OnProgramFinished := CmdProgramFinished;


  FlagDisplay1:= TFlagDisplay.Create(self);
  FlagDisplay1.isTriState := false;
  FlagDisplay1.Top := Shape1.Top+1;
  FlagDisplay1.Left := Shape1.Left+2;
  FlagDisplay1.ImageList := ImageList2;
  FlagDisplay1.OnChange := FlagDisplay1Change;
  FlagDisplay1.Parent := self;

  DrawGrid1.colWidths[3] := 128;
  //InsertControl(FlagDisplay1);

  FlagDisplay2:= TFlagDisplay.Create(self);
  FlagDisplay2.isTriState := true;
  FlagDisplay2.Top := Shape2.Top+2;
  FlagDisplay2.Left := Shape2.Left+2;
  FlagDisplay2.ImageList := ImageList3;
  //FlagDisplay2.OnChange := FlagDisplay1Change;
  FlagDisplay2.Parent := GroupBox1;
  FlagDisplay2.State := $00000000;

//  UsbDevicePath := '';
  hInOutLib := 0;
  Inp32:= nil;
  Out32:= nil;


  IOPort:=$378;

  CurProject:=AppPath + 'default.rtp';
  LoadFromFile(CurProject);
  CurProject:='';

  Caption := 'Kemo - Relais Timer';

  CurrentState:=0;
  FlagDisplay1.State := 0;

  with TRegistry.Create do begin
    if OpenKey(RegistryFolderBase+'\'+Name, false) then begin
      if ValueExists('Port') then IOPort := ReadInteger('Port');
      if ValueExists('Top') then Top := ReadInteger('Top');
      if ValueExists('Left') then Left := ReadInteger('Left');
      CloseKey;
    end;
    Free;
  end;

  PortSettingsChanged;

  if ParamCount>0 then begin
    if FileExists(ParamStr(1)) then begin
      LoadFromFile(ParamStr(1));
      if (ParamCount>1)and(ParamStr(2)='-s') then begin
        CloseRelaisTimerOnEndOfProgram:=1;
        TimerProgram.Start;
      end;
    end;
  end;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
var i:integer;
begin
  with TRegistry.Create do begin
    if OpenKey(RegistryFolderBase+'\'+Name, true) then begin
      WriteInteger('Port',IOPort);
      WriteInteger('Top',Top);
      WriteInteger('Left',Left);
      CloseKey;
    end;
    Free;
  end;

  if usb<>nil then begin
    usb.Disconnect;
    usb.Free;
    usb:=nil;
  end;

  for i:=0 to TimerProgram.count-1 do begin
    //DrawGrid1.RemoveControl(TimerProgram.Items[i].FlagDisplay);
    TimerProgram.Items[i].FlagDisplay.Parent := nil;
  end;
  TimerProgram.Free;
  FlagDisplay1.Free;
  if hInOutLib<>0 then FreeLibrary(hInOutLib);
end;

// feeds the parallel port with bits
procedure TMainForm.ApplyState;
begin
  if (IOPort<(kemo_USBPort+255)) then begin
    usb.SetState(CurrentState);
  end else begin
    if @Out32<>nil then Out32(IOPort,$ff00 or CurrentState);
  end;
end;

procedure TMainForm.bEditClick(Sender: TObject);
begin
  DrawGrid1DblClick(Sender);
  DrawGrid1.Invalidate;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.About1Click(Sender: TObject);
begin
  Application.MessageBox('Relais timer software v2.2 Kemo Electronic GmbH - Germany 2016','About',0);
end;

procedure TMainForm.Button12Click(Sender: TObject);
begin
  with TButton(Sender) do begin
    if Caption = 'Right' then begin
      Caption := 'Left';
    end else
    if Caption = 'Left' then begin
      Caption := 'Pause';
    end else begin
      Caption := 'Right';
    end;
  end;
end;

procedure TMainForm.Save1Click(Sender: TObject);
var i: integer;
  S: TStringList;
begin
  if CurProject='' then begin
    SaveAs1Click(Sender);
    exit;
  end;
  S:= TStringList.Create;
  S.Add(format('Port = %x',[IOPort]));
  if CheckBox1.Checked then S.Add('looping = 1')
  else S.Add('looping = 0');


  
  for i:=0 to TimerProgram.count-1 do with TimerProgram.Items[i] do begin
    S.Add(format('StateChange = %.9f %.9f %x %d',[StartTime,Interval,FlagDisplay.State,Iterations]));
  end;

  S.SaveToFile(CurProject);
  S.Free;
end;

procedure TMainForm.SaveAs1Click(Sender: TObject);
var D: TSaveDialog;
begin
  D:=TSaveDialog.Create(self);
  D.DefaultExt := 'rtp'; // step motor program
  D.Filter := 'relais timer program (*.rtp)|*.rtp';
  isEditing := true;
  if D.Execute then begin
    CurProject := D.FileName;
    Caption := 'Kemo - Relais Timer - '+ CurProject;
    Save1Click(Self);
  end;
  isEditing := RadioGroup1.ItemIndex=2;
end;

procedure TMainForm.OpenProject1Click(Sender: TObject);
var D: TOpenDialog;

begin
  D:=TOpenDialog.Create(self);
  D.DefaultExt := 'rtp';
  D.Filter := 'relais timer program (*.rtp)|*.rtp';
  isEditing := true;
  if D.Execute then begin
    CurProject := D.FileName;
    if not FileExists(CurProject) then begin
      CurProject:='';
      Caption := 'Kemo - Relais Timer';
      D.Free;
      isEditing := RadioGroup1.ItemIndex=2;
      exit;
    end;
    LoadFromFile(CurProject);
    //PortSettingsChanged;
  end;
  D.Free;
  isEditing := RadioGroup1.ItemIndex=2;
end;

function HexToIntDef(S: string; def: integer):integer;
var i,n: integer;
begin
  result:=0;
  n:=0;
  for i:=1 to Length(S) do begin
    case S[i] of
    'A'..'F': n:= byte(S[i]) - byte('A') +10;
    'a'..'f': n:= byte(S[i]) - byte('a') +10;
    '0'..'9': n:= byte(S[i]) - byte('0');
    else begin
      result:=def;
      exit;
    end;end;
    result := (result shl 4) + n;
  end;
end;

procedure TMainForm.LoadFromFile(CurProject: string);
var
 S: TStringList;
 i,j,k,n: integer;
 P: PChar;
 C: array[0..7,0..255]of char;
begin
  if not FileExists(CurProject) then exit;

    TimerProgram.Reset;
    for i:=0 to TimerProgram.count-1 do begin
      TimerProgram.Items[i].FlagDisplay.Parent := nil;
    end;
    TimerProgram.Clear;

    Caption := 'Kemo - Relais Timer - '+ CurProject;

    S:= TStringList.Create;
    S.LoadFromFile(CurProject);
    for j:=0 to S.Count-1 do begin
      P:=PChar(S[j]);
      i:=0; n:=0;
      while true do begin
        k:=0;
        while (P[n]<>#0)and((P[n]=' ')or(P[n]='='))do inc(n);
        if P[n]=#0 then break;
        while (P[n]<>#0)and(P[n]<>' ')and(P[n]<>'=')do begin
          if (P[n]=',') then C[i,k] := '.'
          else C[i,k] := P[n];
          inc(k);
          inc(n);
        end;
        C[i,k] := #0;
        if k>0 then inc(i);
        if P[n]=#0 then break;
      end;
      if i=0 then continue;
      if C[0]='StateChange' then begin
        if i<4 then continue;
        DrawGrid1.RowCount := TimerProgram.count+1;
        with TimerProgram.Add^ do begin
          FlagDisplay := TFlagDisplay.Create(DrawGrid1);
          FlagDisplay.ImageList := ImageList1;
          //DrawGrid1.InsertControl(FlagDisplay);
          FlagDisplay.Parent:=DrawGrid1;
          StartTime := StrToFloatDef(C[1],0);
          Interval := StrToFloatDef(C[2],0);
          FlagDisplay.State:= HexToIntDef(C[3],$378);
          if i>3 then Iterations := StrToIntDef(C[4],0);
        end;
      end else
      if C[0]='looping' then begin
        if i>1 then CheckBox1.Checked := StrToIntDef(C[1],0)<>0;
      {end else
      {f C[0]='Port' then begin
        if i>1 then begin
          IOPort := HexToIntDef(C[1],$378);
          PortSettingsChanged;
        end;}
      end;
    end;
    S.Free;
    DrawGrid1.Row := 0;//DrawGrid1.rowCount-1;
    DrawGrid1.ClientHeight := DrawGrid1.RowCount* DrawGrid1.DefaultRowHeight;
    SortProgramList;
end;


procedure TMainForm.PortSettingsChanged;
begin

  if (IOPort<(kemo_USBPort+255)) then begin
    if hInOutLib<>0 then FreeLibrary(hInOutLib);
    hInOutLib:=0;
    @Inp32:= nil;
    @Out32:= nil;

    if usb=nil then usb:=TKemoUSB.Create;
    usb.Disconnect;
    usb.Connect(IOPort);

    if usb.Connected then begin
      Label4.Caption := 'Port: USB('+ IntToStr(kemo_USBPort+1) +') (connected)';
    end else begin
      Label4.Caption := 'Port: USB (no Device)';
    end;

  end else begin
    if usb<>nil then begin
      usb.Disconnect;
      usb.Free;
      usb:=nil;
    end;

    if (hInOutLib=0) then begin
      //if NeedVistaOr64bitInputDll>0 then begin
      //  hInOutLib := LoadLibrary('inpoutx64.dll');
      //end else begin
        hInOutLib := LoadLibrary('inpout32.dll');
      //end;

      if hInOutLib=0 then begin
        Application.MessageBox('Could not load inpout32.dll. This Application won''t be able to access the parallel port','Error',0);
      end else begin
        Inp32:= GetProcAddress(hInOutLib,'Inp32');
        Out32:= GetProcAddress(hInOutLib,'Out32');
        Out32(IOPort+1,$00);
        Out32(IOPort+2,$00);
        CurrentState:= Inp32(IOPort);
        FlagDisplay1.State := CurrentState;
      end;

    end;

    case IOPort of
      $378: begin Label4.Caption := 'Port: LPT1 ('+IntToHex(IOPort,4)+')';
                  ComboBox1.ItemIndex := 1; end;
      $278: begin Label4.Caption := 'Port: LPT2 ('+IntToHex(IOPort,4)+')';
                  ComboBox1.ItemIndex := 2; end;
      $3BC: begin Label4.Caption := 'Port: LPT3 ('+IntToHex(IOPort,4)+')';
                  ComboBox1.ItemIndex := 3; end;
      else begin Label4.Caption := 'Port: '+IntToHex(IOPort,4); end;
                 //ComboBox1.Text := IntToHex(IOPort,3); end;
    end;
    case IOPort of
      $378: ComboBox1.ItemIndex := 5;
      $278: ComboBox1.ItemIndex := 6;
      $3BC: ComboBox1.ItemIndex := 7;
      else ComboBox1.ItemIndex := kemo_USBPort;
    end;
  end;
end;

procedure TMainForm.NewProject1Click(Sender: TObject);
var i: integer;
begin
  TimerProgram.Reset;
  CurProject:='';
  Caption := 'Kemo - Relais Timer';
  for i:=TimerProgram.count-1 downto 1 do begin
    TimerProgram.Items[i].FlagDisplay.Parent := nil;
    TimerProgram.Delete(i);
  end;
  DrawGrid1.RowCount := 1;
  DrawGrid1.ClientHeight := DrawGrid1.RowCount*DrawGrid1.DefaultRowHeight;
end;

procedure TMainForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
  #0..#31,'0'..'9','-','.':;
  else Key := #0;
  end;
end;

procedure TMainForm.Readme1Click(Sender: TObject);
begin
  if 32 >= ShellExecute(handle,'open','readme.html',nil,PChar(AppPath),SW_SHOW) then begin
    ShellExecute(handle,'open','readme.txt',nil,PChar(AppPath),SW_SHOW);
  end;
end;

procedure TMainForm.Help2Click(Sender: TObject);
begin
  if 32 >= ShellExecute(handle,'open','help.html',nil,PChar(AppPath),SW_SHOW) then begin
    ShellExecute(handle,'open','help.txt',nil,PChar(AppPath),SW_SHOW);
  end;
end;

procedure TMainForm.HilfeDeutsch1Click(Sender: TObject);
begin
  if 32 >= ShellExecute(handle,'open','help_german.html',nil,PChar(AppPath),SW_SHOW) then begin
    ShellExecute(handle,'open','help_german.txt',nil,PChar(AppPath),SW_SHOW);
  end;
end;

procedure TMainForm.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  TS: string;
  bmp: TBitmap;

  f: double;
  h,m,s,n,t: integer;
begin

  if TimerProgram.count <= ARow then begin
    DrawGrid1.Canvas.Brush.Color := clWindow;
    DrawGrid1.Canvas.FillRect(rect);
    exit;
  end;


  ARow := ARow+1;
  case ACol of
  0: begin
      DrawGrid1.Canvas.Brush.Color := clWindow;
      DrawGrid1.Canvas.FillRect(rect);

      DrawGrid1.Canvas.Pen.Color := clBtnShadow;
      DrawGrid1.Canvas.MoveTo(Rect.Right,Rect.Top);
      DrawGrid1.Canvas.LineTo(Rect.Right,Rect.Bottom);

      if TimerProgram.CurrentStep+1 = ARow then begin
        DrawGrid1.Canvas.Font.Color:= clGreen;
        DrawGrid1.Canvas.Font.Style := [fsBold];
        DrawGrid1.Canvas.TextOut(rect.Left+2,rect.Top+2, IntToStr(ARow));
        DrawGrid1.Canvas.Font.Style := [];
        DrawGrid1.Canvas.Font.Color:= clBlack;
      end else
        DrawGrid1.Canvas.TextOut(rect.Left+2,rect.Top+2, IntToStr(ARow));
    end;
  1: begin
      DrawGrid1.Canvas.Brush.Color := clWindow;
      DrawGrid1.Canvas.FillRect(rect);
      DrawGrid1.Canvas.Pen.Color := clBtnShadow;
      DrawGrid1.Canvas.MoveTo(Rect.Right,Rect.Top);
      DrawGrid1.Canvas.LineTo(Rect.Right,Rect.Bottom);
      {if (gdSelected in State) or (gdFocused in State) then begin

      end else begin
        DrawGrid1.Canvas.Font.Style := [];
      end;}

      f := TimerProgram.Items[ARow-1].StartTime;
      if f <= 0 then begin  // relative time
        DrawGrid1.Canvas.Font.Style := [fsBold];
        t:= trunc(-f);
        h:= t div 3600;
        t:=t-(h*3600);
        m:= t div 60;
        s:=t-(m*60);
        n:= round(1000*frac(-f));

        DrawGrid1.Canvas.Font.Color:= clMaroon;
        TS:=format('.%.3d',[n]);
        n:=DrawGrid1.Canvas.TextWidth('.555') + 5;
        DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);
        DrawGrid1.Canvas.Font.Color:= clBlack;

        TS := format('%.2d',[s]);
        n:=n+DrawGrid1.Canvas.TextWidth('55') + 1;
        DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);

        if (h>0) or (m>0) then begin
          TS := format('%.2d:',[m]);
          n:=n+DrawGrid1.Canvas.TextWidth('55:') + 1;
          DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);
        end;

        if h>0 then begin
          TS := format('%d:',[h]);
          n:=n+DrawGrid1.Canvas.TextWidth(TS) + 1;
          DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);
        end;

        TS := '+';
        n:=n+DrawGrid1.Canvas.TextWidth(TS) + 3;

        bmp:=TBitmap.Create;
        ImageList4.GetBitmap(0,bmp);
        DrawGrid1.Canvas.Draw(rect.Right - n,rect.Top+2,bmp);
        bmp.Free;

//        DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);
        DrawGrid1.Canvas.Font.Style := [];
      end else begin // date time        end;
        TS := FormatDateTime('tt',f);
        n:=DrawGrid1.Canvas.TextWidth(TS+'.555') + 5;
        DrawGrid1.Canvas.Font.Color:= $00004000;
        DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);
        if f>1 then begin
          TS := FormatDateTime('ddddd',f);
          DrawGrid1.Canvas.TextOut(rect.Left + 3,rect.Top+2, TS);
          DrawGrid1.Canvas.Font.Color:= clBlack;
        end;
      end;
    end;
  2:begin
      DrawGrid1.Canvas.Brush.Color := clWindow;
      DrawGrid1.Canvas.FillRect(rect);
      f := TimerProgram.Items[ARow-1].Interval;
      if f > 0 then begin  // relative time
        t:= trunc(f);
        h:= t div 3600;
        t:=t-(h*3600);
        m:= t div 60;
        s:=t-(m*60);
        n:= round(1000*frac(f));

        DrawGrid1.Canvas.Font.Style := [fsBold];
        DrawGrid1.Canvas.Font.Color:= clMaroon;

        TS:=format('.%.3d',[n]);
        n:=DrawGrid1.Canvas.TextWidth('.555') + 5;
        DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);

        DrawGrid1.Canvas.Font.Color:= clBlack;

        TS := format('%.2d',[s]);
        n:=n+DrawGrid1.Canvas.TextWidth('55') + 1;
        DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);

        if (h>0) or (m>0) then begin
          TS := format('%.2d:',[m]);
          n:=n+DrawGrid1.Canvas.TextWidth('55:') + 1;
          DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);
        end;

        if h>0 then begin
          TS := format('%d:',[h]);
          n:=n+DrawGrid1.Canvas.TextWidth(TS) + 1;
          DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);
        end;

        //TS := '+';
        //n:=n+DrawGrid1.Canvas.TextWidth(TS) + 3;
        //DrawGrid1.Canvas.TextOut(rect.Right - n,rect.Top+2, TS);
        DrawGrid1.Canvas.Font.Style := [];

        if TimerProgram.Items[ARow-1].Iterations>0 then begin
          TS := IntToStr(TimerProgram.Items[ARow-1].Iterations) + '';
          //n:=n+DrawGrid1.Canvas.TextWidth(TS) + 8;
          DrawGrid1.Canvas.TextOut(rect.Left + 3,rect.Top+2, TS);
        end;

      end;
    end;
  3:begin
      if TimerProgram.count >= ARow then begin
        if TimerProgram.Items[ARow-1].FlagDisplay.Left=0 then begin
          //DrawGrid1.InsertControl(TimerProgram.Items[ARow-1].FlagDisplay);
          TimerProgram.Items[ARow-1].FlagDisplay.Parent := DrawGrid1;
          TimerProgram.Items[ARow-1].FlagDisplay.Visible := true;
        end;
        TimerProgram.Items[ARow-1].FlagDisplay.Top := rect.Top;
        TimerProgram.Items[ARow-1].FlagDisplay.Left := rect.Left;
        TimerProgram.Items[ARow-1].FlagDisplay.Invalidate;
        //TimerProgram.Items[ARow-1].FlagDisplay.Repaint;// Paint;
          //DrawGrid1.InsertControl(TimerProgram.Items[ARow-1].FlagDisplay);
        //end;
        //TimerProgram.Items[ARow-1].FlagDisplay.PaintTo(DrawGrid1.Canvas,1,1);
      end;
    end;
  end;
  if (ACol<3) and (gdSelected in State) then begin
    DrawGrid1.Canvas.Pen.Color := clBtnShadow;
    DrawGrid1.Canvas.MoveTo(Rect.Left,Rect.Top);
    DrawGrid1.Canvas.LineTo(Rect.Right,Rect.Top);
    DrawGrid1.Canvas.MoveTo(Rect.Left,Rect.Bottom-1);
    DrawGrid1.Canvas.LineTo(Rect.Right,Rect.Bottom-1);
  end;
end;

procedure TMainForm.DeleteSelectedRow;
var
  n: integer;
begin
  n:=DrawGrid1.Selection.Top;
  if (n<0)or(n>=TimerProgram.count) then exit;
  TimerProgram.Delete(n);
  DrawGrid1.RowCount := TimerProgram.count;
  if TimerProgram.count>0 then DrawGrid1.ClientHeight := (DrawGrid1.RowCount)*DrawGrid1.DefaultRowHeight;
  DrawGrid1.Invalidate;
end;

procedure TMainForm.AddRow;
var T : prtTimeProgramStep;
begin
  DrawGrid1.RowCount := TimerProgram.count+1;// DrawGrid1.RowCount+1;
  T:= TimerProgram.Add;
  with T^ do begin
    StartTime := SpinEdit1.Value * 3600
               + SpinEdit2.Value * 60
               + SpinEdit3.Value
               + SpinEdit4.Value *0.001;
    StartTime := -StartTime;

    if (StartTime=0) and (TimerProgram.count>1) then begin
      Starttime := TimerProgram.Items[TimerProgram.count-2].StartTime;
    end;


    FlagDisplay := TFlagDisplay.Create(DrawGrid1);
    FlagDisplay.Visible := false;
    FlagDisplay.State := FlagDisplay2.State;
    FlagDisplay.ImageList := ImageList1;
    DrawGrid1.InsertControl(FlagDisplay);
    FlagDisplay.Parent := DrawGrid1;
  end;
  DrawGrid1.Row := DrawGrid1.rowCount-1;
  DrawGrid1.ClientHeight := (DrawGrid1.RowCount)*DrawGrid1.DefaultRowHeight;
  SortProgramList;
  //ScrollBox1.ScrollInView(DrawGrid1);// ScrollBy(0,1000);
end;

procedure TMainForm.bInsertClick(Sender: TObject);
begin
  AddRow;
end;

procedure TMainForm.DrawGrid1DblClick(Sender: TObject);
var
  n: integer;
  D: TrtTimeDlg;
begin
  n:=DrawGrid1.Selection.Top;
  if (n<0)or(n>=TimerProgram.count) then exit;
  D:=TrtTimeDlg.Create(self);
  D.StartTime:= TimerProgram.Items[n].StartTime;
  D.Interval := TimerProgram.Items[n].Interval;
  D.Iterations := TimerProgram.Items[n].Iterations;
  isEditing := true;
  if D.ShowModal = mrOK then begin
    TimerProgram.Items[n].StartTime := D.StartTime;
    TimerProgram.Items[n].Interval := D.Interval;
    TimerProgram.Items[n].Iterations := D.Iterations;
    SortProgramList;
  end;
  isEditing := RadioGroup1.ItemIndex=2;
end;

procedure TMainForm.bStartClick(Sender: TObject);
begin
  if TimerProgram.IsExecuting then begin
//    TimerProgram.Stop;
//    Button9.Caption := 'Start';
  end else begin
    TimerProgram.Start;
    TimerProgram.IsLooping := CheckBox1.Checked;
//    Button4.Caption := 'Pause';
  end;
end;

procedure TMainForm.bStopClick(Sender: TObject);
begin
  if TimerProgram.IsExecuting then begin
    TimerProgram.Stop;
    bStart.Caption := 'Start';
  end;
end;

procedure TMainForm.bAllOFFClick(Sender: TObject);
begin
  CmdStateChange(0);
end;

procedure TMainForm.bAllONClick(Sender: TObject);
begin
  CmdStateChange($ff);
end;

procedure TMainForm.bStepClick(Sender: TObject);
begin
  TimerProgram.Step;
end;

procedure TMainForm.CheckBox6Click(Sender: TObject);
begin
  TimerProgram.IsLooping := CheckBox1.Checked;
end;

procedure TMainForm.bDeleteClick(Sender: TObject);
begin
  DeleteSelectedRow;
end;

procedure TMainForm.ToggleSelectedFlagDisplay(index: integer);
var
  StateMask,i,f,m,n: integer;
begin
  n:=DrawGrid1.Selection.Top;//-1;
  if (n<0)or(n>=TimerProgram.count) then exit;
  TimerProgram.Items[n].FlagDisplay.Toggle(index);
  DrawGrid1.Invalidate;
  exit;

  StateMask := $ffff0000 or (1 shl index);

  i:=TimerProgram.Items[n].FlagDisplay.State;
  m:=StateMask shr 16;
  f:=StateMask and $ffff;
  i := i xor f;
  i := (i and m) or (f and not m);
  TimerProgram.Items[n].FlagDisplay.State := i;
end;

procedure TMainForm.DrawGrid1KeyPress(Sender: TObject; var Key: Char);
var
  i,n: integer;
begin
  n:=DrawGrid1.Selection.Top;//-1;
  if (n<0)or(n>=TimerProgram.count) then exit;

  case Key of
    #13 : DrawGrid1DblClick(self);
    '1': ToggleSelectedFlagDisplay(0);
    '2': ToggleSelectedFlagDisplay(1);
    '3': ToggleSelectedFlagDisplay(2);
    '4': ToggleSelectedFlagDisplay(3);
    '5': ToggleSelectedFlagDisplay(4);
    '6': ToggleSelectedFlagDisplay(5);
    '7': ToggleSelectedFlagDisplay(6);
    '8': ToggleSelectedFlagDisplay(7);
    '9': begin
           for i:=0 to 7 do TimerProgram.Items[n].FlagDisplay.Toggle(i);
           DrawGrid1.Invalidate;
         end;
    '0': begin
           TimerProgram.Items[n].FlagDisplay.Toggle(0);
           i:=TimerProgram.Items[n].FlagDisplay.State;
           i:=i and $00010001;
           i:=i or (i shl 1);
           i:=i or (i shl 2);
           i:=i or (i shl 4);

           TimerProgram.Items[n].FlagDisplay.State := i;
           DrawGrid1.Invalidate;
         end;

  end;

end;

procedure TMainForm.SelectedItemIncTime(t: double);
var
  h: double;
  n: integer;
begin
  n:=DrawGrid1.Selection.Top;
  if (n<0)or(n>=TimerProgram.count) then exit;

  h:=TimerProgram.Items[n].StartTime;
  if (h+t>0) then h:=0
  else h:=h+t;
  TimerProgram.Items[n].StartTime := h;
  
  SortProgramList;
end;

procedure TMainForm.DrawGrid1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var b: boolean;
begin
  case Key of
    VK_INSERT: bInsertClick(nil);
    VK_DELETE: bDeleteClick(nil);
    VK_DOWN: begin
               b:=false;
               if (ssAlt in Shift) then SelectedItemIncTime(-60) else
               if (ssShift in Shift)
               and (ssCtrl in Shift) then SelectedItemIncTime(-3600) else
               if (ssShift in Shift) then SelectedItemIncTime(-1) else
               if (ssCtrl in Shift) then SelectedItemIncTime(-0.05) else
               b:=true;
               if not b then Key := 0;
             end;
    VK_UP:   begin
               b:=false;
               if (ssAlt in Shift) then SelectedItemIncTime(60) else
               if (ssShift in Shift)
               and (ssCtrl in Shift) then SelectedItemIncTime(3600) else
               if (ssShift in Shift) then SelectedItemIncTime(1) else
               if (ssCtrl in Shift) then SelectedItemIncTime(0.05) else
               b:=true;
               if not b then Key := 0;
             end;
  end;

end;


procedure TMainForm.ApplicationEvents1Message(var Msg: tagMSG; var Handled: Boolean);
begin
  if (Msg.message <> WM_KEYDOWN)and(Msg.message <> WM_KEYUP)
  and(Msg.message <> WM_SYSKEYDOWN)then exit;
  if isEditing {or DrawGrid1.Focused} then exit;
  Handled := true;

  if msg.message = WM_KEYUP then begin
    if RadioGroup1.ItemIndex = 0 then case Msg.wParam of
      VK_F1: CmdStateChange($fffe0000);
      VK_F2: CmdStateChange($fffd0000);
      VK_F3: CmdStateChange($fffb0000);
      VK_F4: CmdStateChange($fff70000);
      VK_F5: CmdStateChange($ffef0000);
      VK_F6: CmdStateChange($ffdf0000);
      VK_F7: CmdStateChange($ffbf0000);
      VK_F8: CmdStateChange($ff7f0000);
      VK_F9: CmdStateChange($ff000000);
//      VK_F10: CmdStateChange($ff000000);
//      VK_F11: CmdStateChange($ff000000);
      else Handled := false;
    end;
  end else
  if msg.message = WM_KEYDOWN then begin
    if RadioGroup1.ItemIndex = 0 then case Msg.wParam of
      VK_F1: CmdStateChange($fffe0001);
      VK_F2: CmdStateChange($fffd0002);
      VK_F3: CmdStateChange($fffb0004);
      VK_F4: CmdStateChange($fff70008);
      VK_F5: CmdStateChange($ffef0010);
      VK_F6: CmdStateChange($ffdf0020);
      VK_F7: CmdStateChange($ffbf0040);
      VK_F8: CmdStateChange($ff7f0080);
      VK_F9: CmdStateChange($ff0000ff);
      VK_F11: CmdStateChange($ff0000ff);
      else Handled := false;
    end else
    if RadioGroup1.ItemIndex = 1 then case Msg.wParam of
      VK_F1: CmdStateChange($ffff0001);
      VK_F2: CmdStateChange($ffff0002);
      VK_F3: CmdStateChange($ffff0004);
      VK_F4: CmdStateChange($ffff0008);
      VK_F5: CmdStateChange($ffff0010);
      VK_F6: CmdStateChange($ffff0020);
      VK_F7: CmdStateChange($ffff0040);
      VK_F8: CmdStateChange($ffff0080);
      VK_F9: CmdStateChange($ffff00ff);
      VK_F11: CmdStateChange($ff0000ff);
      else Handled := false;
    end;
  end else
  if (msg.message = WM_SYSKEYDOWN)and(msg.wParam=VK_F10) then begin
    if RadioGroup1.ItemIndex < 2 then CmdStateChange($ff000000);
  end else
    Handled := false;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
var d: TDateTime;
begin
  d:=Now;
  StaticText1.Caption := FormatDateTime('ddddd',d);
  StaticText2.Caption := FormatDateTime('tt',d);
  if TimerProgram.IsExecuting then
  StaticText3.Caption := FormatDateTime('tt.zzz',d-TimerProgram.StartTime)
  else StaticText3.Caption := '00:00:00.000';

  //hax
  if CloseRelaisTimerOnEndOfProgram>1 then begin
    if CloseRelaisTimerOnEndOfProgram=5 then PostMessage(Handle,WM_CLOSE,0,0)
    else inc(CloseRelaisTimerOnEndOfProgram);
  end;
end;

procedure TMainForm.RadioGroup1Click(Sender: TObject);
begin
  isEditing := RadioGroup1.ItemIndex=2;
end;

procedure TMainForm.SortProgramList;
var n: integer;
begin
  n:=DrawGrid1.Selection.Top;//-1;
  if (n<0)or(n>=TimerProgram.count) then exit;
  TimerProgram.Items[n].selected := true;
  TimerProgram.Sort;
  DrawGrid1.Invalidate;

  for n:=0 to TimerProgram.count-1 do begin
    if TimerProgram.Items[n].selected then begin
      DrawGrid1.Row := n;
      //DrawGrid1.Selection.Top := n;
      TimerProgram.Items[n].selected := false;
      break;
    end;
  end;

end;

procedure TMainForm.SpinEditChange(Sender: TObject);
begin
  with Sender as TSpinEdit do begin
    if Text = '' then exit;
    if (Value >= MaxValue) then Value := MinValue + Increment;
    if (Value <= MinValue) then Value := MaxValue - Increment;
  end;
end;

procedure TMainForm.SpinEdit3KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then AddRow;
end;

procedure TMainForm.SpinEdit1Exit(Sender: TObject);
begin
  if TSpinEdit(sender).Text = '' then TSpinEdit(sender).Value := 0;
end;

procedure TMainForm.wmDeviceChange(var Message: TMessage);
begin
  if (usb<>nil) and (usb.Connected) then begin
    ApplyState;
  end else
    PortSettingsChanged;
end;

procedure TMainForm.ComboBox1Change(Sender: TObject);
begin
  case ComboBox1.ItemIndex of
    0: IOPort := kemo_USBPort;
    1: IOPort := kemo_USBPort2;
    2: IOPort := kemo_USBPort3;
    3: IOPort := kemo_USBPort4;
    4: IOPort := kemo_USBPort5;
    5: IOPort := $378;
    6: IOPort := $278;
    7: IOPort := $3BC;
    else IOPort := HexToIntDef(ComboBox1.Text,$378);
    //else exit;
  end;
  PortSettingsChanged;
end;

procedure TMainForm.SpeedButton3Click(Sender: TObject);
begin
  CmdStateChange($ffff00ff);
end;

procedure TMainForm.ApplicationEvents1ShortCut(var Msg: TWMKey;
  var Handled: Boolean);
begin
  if Msg.CharCode = VK_F12 then begin
    if TimerProgram.IsExecuting then bStopClick(nil)
    else bStartClick(nil);
  end;
end;

end.
