unit rTimeDlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, 
  ExtCtrls, Mask,strutils, Spin, Buttons;

type
  TrtTimeDlg = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox2: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    DateTimePicker2: TDateTimePicker;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    CheckBox1: TCheckBox;
    GroupBox3: TGroupBox;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Label5: TLabel;
    Label6: TLabel;
    SpinEdit3: TSpinEdit;
    SpinEdit4: TSpinEdit;
    Label7: TLabel;
    Label4: TLabel;
    SpinEdit5: TSpinEdit;
    SpinEdit6: TSpinEdit;
    Label8: TLabel;
    Label9: TLabel;
    SpinEdit7: TSpinEdit;
    SpinEdit8: TSpinEdit;
    Label10: TLabel;
    Label3: TLabel;
    SpinEdit9: TSpinEdit;
    SpinEdit10: TSpinEdit;
    Label11: TLabel;
    Label12: TLabel;
    SpinEdit11: TSpinEdit;
    SpinEdit12: TSpinEdit;
    Label13: TLabel;
    Label14: TLabel;
    SpinEdit13: TSpinEdit;
    SpeedButton1: TSpeedButton;
    Label15: TLabel;
    procedure CheckBox1Click(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton5Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpinEditChange(Sender: TObject);
    procedure SpinEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpinEdit5Exit(Sender: TObject);
    procedure SpinEdit13Change(Sender: TObject);
  private
    fInterval: double;
    fStartTime: double;
    fIterations: integer;
    function GetInterval: double;
    function GetStartTime: double;
    procedure SetInterval(const Value: double);
    procedure SetStartTime(const Value: double);
    procedure SetIterations(const Value: integer);
  public
    property StartTime: double read fStartTime write SetStartTime;
    property Interval: double read fInterval write SetInterval;
    property Iterations: integer read fIterations write SetIterations;
  end;

  function SecondsToString(seconds: double): string;
  function StringToSeconds(M: string): double;
implementation

{$R *.dfm}

{ TrtTimeDlg }
function SecondsToString(seconds: double): string;
var h,m,s,n,t: integer;
begin
  t:= trunc(seconds);
  h:= t div 3600;
  t:=t-(h*3600);
  m:= t div 60;
  s:=t-(m*60);
  n:= round(1000*frac(seconds));
  if h>23 then h:=23;
  result := format(' %.2d : %.2d : %.2d . %.3d',[h,m,s,n]);
//  result:= '00:00:00.000';
end;

function StringToSeconds(M: string): double;
var t: double;
S: string;
begin
  S:=Copy(M,1,2);
  t:=StrToIntDef(S,0);
  S:=Copy(M,4,2);
  t:=60*t + StrToIntDef(S,0);
  S:=Copy(M,7,2);
  t:=60*t + StrToIntDef(S,0);
  S:=Copy(M,10,3);
  t:=t + 0.001*StrToIntDef(S,0);
  result:=t;
end;

procedure TrtTimeDlg.SetInterval(const Value: double);
var h,m,s,n,t: integer;
begin
  if Value>0 then begin
    PageControl1.ActivePageIndex:=1;
    RadioButton2.Checked := true;
    t:= trunc(Value);
    h:= t div 3600;
    t:=t-(h*3600);
    m:= t div 60;
    s:=t-(m*60);
    n:= round(1000*frac(Value));
    SpinEdit9.Value := h;
    SpinEdit10.Value := m;
    SpinEdit11.Value := s;
    SpinEdit12.Value := n;
  end else begin
    RadioButton1.Checked := true;
    SpinEdit9.Value := 0;
    SpinEdit10.Value := 0;
    SpinEdit11.Value := 0;
    SpinEdit12.Value := 0;
  end;
  RadioButton2Click(self);
end;

procedure TrtTimeDlg.SetStartTime(const Value: double);
var f: double;
  h,m,s,n,t: integer;
begin
  if Value>0 then begin // value = TDateTime
    f := 24*3600* frac(Value) + 0.00025; // cut off the days and convert to seconds
    t:= trunc(f);
    h:= t div 3600;
    t:=t-(h*3600);
    m:= t div 60;
    s:=t-(m*60);
    n:= round(1000*frac(f));

    RadioButton5.Checked := true;
    PageControl1.ActivePageIndex:=1;
    CheckBox1.Enabled := true;

    //MaskEdit1.Text := SecondsToString(f);
    if Value>1 then begin
      CheckBox1.Checked := true;
      DateTimePicker2.Enabled := true;
      DateTimePicker2.Date := Value;
    end else begin
      CheckBox1.Checked := false;
      DateTimePicker2.Enabled := false;
      DateTimePicker2.Date := Now;
    end;
  end else begin // value = -seconds
    t:= trunc(-Value);
    h:= t div 3600;
    t:=t-(h*3600);
    m:= t div 60;
    s:=t-(m*60);
    n:= round(1000*frac(-Value));

    RadioButton4.Checked := true;
    CheckBox1.Enabled := false;
    DateTimePicker2.Date := Now;
    DateTimePicker2.Enabled := false;
    //MaskEdit1.Text := SecondsToString(-Value);
  end;
  SpinEdit1.Value := h;
  SpinEdit2.Value := m;
  SpinEdit3.Value := s;
  SpinEdit4.Value := n;
  SpinEdit5.Value := h;
  SpinEdit6.Value := m;
  SpinEdit7.Value := s;
  SpinEdit8.Value := n;
end;

procedure TrtTimeDlg.CheckBox1Click(Sender: TObject);
begin
  DateTimePicker2.Enabled := CheckBox1.Checked;
end;

procedure TrtTimeDlg.RadioButton4Click(Sender: TObject);
begin
  CheckBox1.Enabled := false;
  CheckBox1.Checked := false;
  SpeedButton1.Enabled := false;
end;

procedure TrtTimeDlg.RadioButton5Click(Sender: TObject);
begin
  SpeedButton1.Enabled := true;
  CheckBox1.Enabled := true;
end;

procedure TrtTimeDlg.RadioButton2Click(Sender: TObject);
begin
  //MaskEdit2.Enabled := RadioButton2.Checked;
  SpinEdit9.Enabled := RadioButton2.Checked;
  SpinEdit10.Enabled := RadioButton2.Checked;
  SpinEdit11.Enabled := RadioButton2.Checked;
  SpinEdit12.Enabled := RadioButton2.Checked;
  SpinEdit13.Enabled := RadioButton2.Checked;
end;

function TrtTimeDlg.GetInterval: double;
begin
  if RadioButton1.Checked then result := 0
  else 
  //result:=StringToSeconds(MaskEdit2.Text);
  result := SpinEdit9.Value * 3600
        + SpinEdit10.Value * 60
        + SpinEdit11.Value
        + SpinEdit12.Value *0.001;
end;

function TrtTimeDlg.GetStartTime: double;
begin
  if PageControl1.ActivePageIndex = 0 then begin
    result := SpinEdit1.Value * 3600
            + SpinEdit2.Value * 60
            + SpinEdit3.Value
            + SpinEdit4.Value *0.001;
    result := -result;
  end else begin
    result := SpinEdit5.Value * 3600
            + SpinEdit6.Value * 60
            + SpinEdit7.Value
            + SpinEdit8.Value *0.001;
    if RadioButton4.Checked then result := -result
    else begin
      result := result * (1/(24*3600));
      if CheckBox1.Checked then result := result + round(DateTimePicker2.Date);
    end;
  end;
end;

procedure TrtTimeDlg.Button1Click(Sender: TObject);
begin
  fStartTime:=GetStartTime;
  if PageControl1.ActivePageIndex=1 then begin
    fInterval:=GetInterval;
    fIterations := SpinEdit13.Value
  end else begin
    fInterval:=0;
    fIterations := 0;
  end;
  ModalResult := mrOk;
end;

procedure TrtTimeDlg.FormShow(Sender: TObject);
begin
  if PageControl1.ActivePageIndex=0 then SpinEdit3.SetFocus
  else SpinEdit7.SetFocus;
end;

procedure TrtTimeDlg.SetIterations(const Value: integer);
begin
  fIterations := Value;
  SpinEdit13.Value := Value;
end;

procedure TrtTimeDlg.SpeedButton1Click(Sender: TObject);
begin
  SetStartTime(Now);
end;

procedure TrtTimeDlg.SpinEditChange(Sender: TObject);
begin
  with Sender as TSpinEdit do begin
    if Text = '' then exit;
    if (Value = MaxValue) then Value := MinValue + 1;
    if (Value = MinValue) then Value := MaxValue - 1;
  end;
end;

procedure TrtTimeDlg.SpinEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then Button1Click(self)
  else if Key = VK_ESCAPE then ModalResult:= mrCancel;
end;

procedure TrtTimeDlg.SpinEdit5Exit(Sender: TObject);
begin
  if TSpinEdit(sender).Text = '' then TSpinEdit(sender).Value := 0;
end;

procedure TrtTimeDlg.SpinEdit13Change(Sender: TObject);
begin
  Label15.Visible := SpinEdit13.Value = 0;
end;

end.
